mod arith;
mod cmp;
mod conditional;

use std::{collections::HashMap, rc::Rc};

pub use arith::{AddOp, MulOp, SubOp};
pub use cmp::{EqOp, GeOp, GtOp, LeOp, LtOp, NeOp};
pub use conditional::OpCond;

use super::Builtin;

pub fn all_builtins() -> HashMap<String, Rc<dyn Builtin>> {
    let mut builtins: HashMap<String, Rc<dyn Builtin>> = HashMap::new();
    builtins.insert("add".to_string(), Rc::new(AddOp));
    builtins.insert("sub".to_string(), Rc::new(SubOp));
    builtins.insert("mul".to_string(), Rc::new(MulOp));
    builtins.insert("if".to_string(), Rc::new(OpCond));
    builtins.insert("ge".to_string(), Rc::new(GeOp));
    builtins.insert("gt".to_string(), Rc::new(GtOp));
    builtins.insert("le".to_string(), Rc::new(LeOp));
    builtins.insert("lt".to_string(), Rc::new(LtOp));
    builtins.insert("eq".to_string(), Rc::new(EqOp));
    builtins.insert("ne".to_string(), Rc::new(NeOp));
    builtins
}
